//--------------------------------------------------------------------------
// Globale Variabeln
//--------------------------------------------------------------------------

color Hintergrund = color (230);                                 // Hintergrundfarbe
color ZelleColor = color (200, 200, 160);                        // Farbe wachsende Zelle
color c1 = color (229);                                          // Farbe Kreis innen
color c2 = color (200, 200, 160);                                // Farbe Kreis Mitte
color c3 = color (180, 180, 160);                                          // Farbe Kreis Mitte
color ZelleFertigColor = color (200);                            // Farbe fertige Zelle
color FensterColor = color (229);                                // Farbe Fenster
int AnzahlZellen = 500;                                          // Anzahl Zellen
int AnzahlOeffnungen = 4;                                        // Anzahl ffnungen
int minRandAbstand = 50;                                         // minimaler Abstand einer ffnung zum Rand
int n = 0;                                                       // Zhler Durchgnge
int m = 5;                                                       // Anzal Wachstumsrunden pro Durchgang
float f = 0.05;                                                   // Wachstum pro Durchgang
float g = 0.15;                                                   // Verschiebung pro Durchgang
float Rand = 2;                                                   // Rand der Kreise
int maxB = 180;                                                  // maximale Fensterbreite
int minB = 50;                                                   // minimale Fensterbreite
int minR = 2;                                                    // minimaler rZelle einer Zelle
int minA = 2;                                                    // minimaler Abstand, darunter = berhrt
boolean schlaufen = false;                                       // draw stoppen/starten ber Mausklick (>s. Funktionen)
boolean alleGezeichnet = false;                                  // Ende ermitteln

oZelle [] meineZelle = new oZelle [AnzahlZellen];                // Zellen-Array generieren
Oeffnung [] meineOeffnung = new Oeffnung [AnzahlOeffnungen];     // Oeffnungs-Array generieren

//--------------------------------------------------------------------------
// Initialisierung
//--------------------------------------------------------------------------

void setup()
{
  size (600, 600);
  // frameRate (5);
  background (Hintergrund);

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [0] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [0].zeichnen ();
  
  noLoop ();
}

//--------------------------------------------------------------------------
// Frame fr Frame wiederholt
//--------------------------------------------------------------------------

void draw ()
{

  for (int j = 1; j <= m; j++)                 // m-mal wachsen, bevor eine neue Zelle generiert wird
  {

    for (int i = 0; i <= n; i++)               // alle bestehenden Zellen "durchschlaufen"
    {
      if (meineZelle [i].getFertig () == false)                            // falls die Zelle noch nicht fertig ist
      {
        int Beruehrungen = meineZelle [i].BeruehrungenZaehlen ();          // Zelle testen
        if (Beruehrungen == 0)                                             // keine Berhrung -> wachsen
        {
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 1)                                         // 1 Berhrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_1();
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 2)                                         // 2 Berhrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_2();
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 3)
        {
           if (meineZelle [i].getGeometrie () [2] < minR)                   // wird neu gestartet, falls sie fertig, aber zu klein ist
          {
            meineZelle [i].reset ();          
          }
          else                                                              // Zelle wird als "fertig" deklariert
          {
            meineZelle [i].setFertig (true);
          }
        }
      }
    }

  }


  if (n < AnzahlZellen-1)                      // Zhler erhhen und neue Zelle generieren, falls Anzahl Zellen noch nicht erreicht ist
  {
    n++;
    meineZelle [n] = new oZelle ();             // neue Zelle generieren
    meineZelle [n].zeichnen ();                // generierte Zelle zeichnen
  }
  else if (alleGezeichnet == false)
  {
    println ("alle Zellen gezeichnet");
    alleGezeichnet = true;
  }

}

